MORParser Class Reference

the main class to read a More file More...

`#include <MORParser.hxx>`

Inheritance diagram for MORParser:

## Public Member Functions

| MORParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MORParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | getColor (int id, MWAWColor &col) const
| return the color which corresponds to an id (if possible) More...
bool | createZones ()
| finds the different objects zones More...
bool | readZonesList ()
| read the list of zones ( v2-3) : first 0x80 bytes More...
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo zone ( first block ) More...
bool | readDocumentInfo (MWAWEntry const &entry)
| read a docinfo zone ( second block ) More...
bool | readSlideList (MWAWEntry const &entry)
| read the list of slide definitions More...
bool | readSlide (MWAWEntry const &entry)
| read a slide definitions More...
bool | readGraphic (MWAWEntry const &entry)
| read a graphic ( in a slide ) More...
bool | readUnknown9 (MWAWEntry const &entry)
| read a unknown zone ( block 9 ) More...
bool | readColors (long endPos)
| read a color zone ( beginning of block 9 ) More...
bool | readPattern (long endPos, MORStruct::Pattern &pattern)
| read a pattern ( some sub zone of block 9) More...
bool | readBackside (long endPos, std::string &extra)
| read a backside ( some sub zone of block 9) More...
bool | readFreePos (MWAWEntry const &entry)
| read the list of free file position More...
bool | readUnkn9Sub (long endPos)
| read the last subzone find in a block 9 ( unknown meaning) More...
bool | checkAndStore (MWAWEntry const &entry)
| check if the entry is valid, if so store it in the list of entry More...
bool | checkAndFindSize (MWAWEntry &entry)
| check if the entry is valid defined by the begin pos points to a zone: dataSz data More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < MORParserInternal::State > | m_state
| the state More...
shared_ptr< MORText > | m_textParser
| the text parser More...

## Friends

class | MORParserInternal::SubDocument
class | MORText

## Detailed Description

the main class to read a More file

## Constructor & Destructor Documentation

MORParser::MORParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

MORParser::~MORParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool MORParser::checkAndFindSize | ( | MWAWEntry & | entry | ) |

protected

check if the entry is valid defined by the begin pos points to a zone: dataSz data

Referenced by MORText::readComment(), MORText::readOutlineList(), readSlideList(), MORText::readSpeakerNote(), and MORText::readTopic().

bool MORParser::checkAndStore | ( | MWAWEntry const & | entry | ) |

protected

check if the entry is valid, if so store it in the list of entry

Referenced by readZonesList().

bool MORParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void MORParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool MORParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

bool MORParser::getColor | ( | int | id,
|  | MWAWColor & | col
| ) |  | const

protected

return the color which corresponds to an id (if possible)

Vec2f MORParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void MORParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MORParser().

void MORParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by MORText::sendTopic().

void MORParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool MORParser::readBackside | ( | long | endPos,
|  | std::string & | extra
| ) |  |

protected

read a backside ( some sub zone of block 9)

Referenced by MORText::parseUnknown(), and readUnknown9().

bool MORParser::readColors | ( | long | endPos | ) |

protected

read a color zone ( beginning of block 9 )

Referenced by readUnknown9().

bool MORParser::readDocumentInfo | ( | MWAWEntry const & | entry | ) |

protected

read a docinfo zone ( second block )

Referenced by createZones().

bool MORParser::readFreePos | ( | MWAWEntry const & | entry | ) |

protected

read the list of free file position

Referenced by createZones().

bool MORParser::readGraphic | ( | MWAWEntry const & | entry | ) |

protected

read a graphic ( in a slide )

Referenced by readSlide().

bool MORParser::readPattern | ( | long | endPos,
|  | MORStruct::Pattern & | pattern
| ) |  |

protected

read a pattern ( some sub zone of block 9)

Referenced by MORText::parseUnknown(), and readUnknown9().

bool MORParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |

protected

read a PrintInfo zone ( first block )

Referenced by createZones().

bool MORParser::readSlide | ( | MWAWEntry const & | entry | ) |

protected

read a slide definitions

Referenced by readSlideList().

bool MORParser::readSlideList | ( | MWAWEntry const & | entry | ) |

protected

read the list of slide definitions

Referenced by createZones().

bool MORParser::readUnkn9Sub | ( | long | endPos | ) |

protected

read the last subzone find in a block 9 ( unknown meaning)

Referenced by readUnknown9().

bool MORParser::readUnknown9 | ( | MWAWEntry const & | entry | ) |

protected

read a unknown zone ( block 9 )

Referenced by createZones().

bool MORParser::readZonesList | ( |  | ) |

protected

read the list of zones ( v2-3) : first 0x80 bytes

Referenced by createZones().

libmwaw::DebugFile & MORParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

MWAWInputStreamPtr MORParser::rsrcInput | ( |  | ) |

protected

return the input input

## Friends And Related Function Documentation

friend class MORParserInternal::SubDocument

friend

friend class MORText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<MORParserInternal::State> MORParser::m_state

protected

the state

Referenced by checkAndStore(), checkHeader(), createDocument(), createZones(), getColor(), getPageLeftTop(), init(), newPage(), readDocumentInfo(), and readZonesList().

shared_ptr<MORText> MORParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and readSlide().

The documentation for this class was generated from the following files:

- MORParser.hxx
- MORParser.cxx